<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑' : '添加'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="场地名称" name="name">
        <a-input
          allow-clear
          placeholder="请输入场地名称"
          v-model:value="form.name"
        />
      </a-form-item>
      <a-form-item label="封面图" name="thumb">
        <a-avatar
          :src="`https://gxtyzx.gxsportscenter.com/uploads/images/${form.thumb}`"
          size="120"
          shape="square"
        />
        <!--        <SelectFile-->
        <!--          :placeholder="`请选择图片`"-->
        <!--          :limit="1"-->
        <!--          :data="images"-->
        <!--          @done="chooseImage"-->
        <!--          @del="onDeleteItem"-->
        <!--        />-->
      </a-form-item>
      <!--      <a-form-item label="场馆图片" name="files">-->
      <!--        <SelectFile-->
      <!--          :placeholder="`请选择图片`"-->
      <!--          :limit="9"-->
      <!--          :data="files"-->
      <!--          @done="chooseFiles"-->
      <!--          @del="onDeleteFiles"-->
      <!--        />-->
      <!--      </a-form-item>-->
      <a-form-item label="每小时价格" name="price">
        <a-input-number
          allow-clear
          placeholder="请输入每小时价格"
          v-model:value="form.price"
        />
      </a-form-item>
      <a-form-item label="营业时间" name="businessTime">
        <a-input
          allow-clear
          placeholder="请输入营业时间"
          v-model:value="form.businessTime"
        />
      </a-form-item>
      <a-form-item label="场馆地址" name="address">
        <a-input
          allow-clear
          placeholder="请输入场馆地址"
          v-model:value="form.address"
        />
      </a-form-item>
      <a-form-item label="场馆介绍" name="info">
        <!-- 编辑器 -->
        <tinymce-editor
          ref="editorRef"
          class="content"
          v-model:value="content"
          :disabled="disabled"
          :init="config"
          placeholder="请输入场馆介绍内容"
        />
      </a-form-item>
      <a-form-item label="场馆电话" name="tel">
        <a-input
          allow-clear
          placeholder="请输入场馆电话"
          v-model:value="form.tel"
        />
      </a-form-item>
      <a-form-item label="类型" name="type">
        <a-input
          allow-clear
          placeholder="请输入类型：1天，2小时"
          v-model:value="form.type"
        />
      </a-form-item>
      <a-form-item label="天数或小时" name="num">
        <a-input
          allow-clear
          placeholder="请输入天数或小时"
          v-model:value="form.num"
        />
      </a-form-item>
      <a-form-item label="退款比率" name="proportion">
        <a-input
          allow-clear
          placeholder="请输入退款比率"
          v-model:value="form.proportion"
        />
      </a-form-item>
      <!--      <a-form-item label="退款规则组" name="moneyJson">-->
      <!--        <a-input-->
      <!--          allow-clear-->
      <!--          placeholder="请输入退款规则组"-->
      <!--          v-model:value="form.moneyJson"-->
      <!--        />-->
      <!--      </a-form-item>-->
      <a-form-item label="周末活动订场开关" name="weekendOpen">
        <a-switch :checked="form.weekendOpen == 1" />
      </a-form-item>
      <a-form-item label="排序" name="sortNumber">
        <a-input
          allow-clear
          placeholder="请输入排序"
          v-model:value="form.sortNumber"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addThinkSite, updateThinkSite } from '@/api/think/thinkSite';
  import { ThinkSite } from '@/api/think/thinkSite/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';
  import TinymceEditor from '@/components/TinymceEditor/index.vue';
  import { uploadOss } from '@/api/system/file';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);
  const disabled = ref(false);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ThinkSite | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);
  const files = ref<ItemType[]>([]);
  // 编辑器内容，双向绑定
  const content = ref<any>('');

  // 用户信息
  const form = reactive<ThinkSite>({
    id: undefined,
    name: undefined,
    thumb: undefined,
    price: undefined,
    businessTime: undefined,
    address: undefined,
    info: undefined,
    tel: undefined,
    sortNumber: undefined,
    type: undefined,
    num: undefined,
    proportion: undefined,
    moneyJson: undefined,
    createTime: undefined,
    updateTime: undefined,
    weekendOpen: undefined
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    thinkSiteName: [
      {
        required: true,
        type: 'string',
        message: '请填写名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.thumb = data.path;
  };

  const chooseFiles = (data: FileRecord) => {
    files.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
  };

  const onDeleteFiles = (index: number) => {
    files.value.splice(index, 1);
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.thumb = '';
  };

  const editorRef = ref<InstanceType<typeof TinymceEditor> | null>(null);
  const config = ref({
    height: 450,
    images_upload_handler: (blobInfo, success, error) => {
      const file = blobInfo.blob();
      const formData = new FormData();
      formData.append('file', file, file.name);
      uploadOss(file)
        .then((res) => {
          success(res.path);
        })
        .catch((msg) => {
          error(msg);
        });
    },
    // 自定义文件上传(这里使用把选择的文件转成 blob 演示)
    file_picker_callback: (callback: any, _value: any, meta: any) => {
      const input = document.createElement('input');
      input.setAttribute('type', 'file');
      // 设定文件可选类型
      if (meta.filetype === 'image') {
        input.setAttribute('accept', 'image/*');
      } else if (meta.filetype === 'media') {
        input.setAttribute('accept', 'video/*,.pdf');
      }
      input.onchange = () => {
        const file = input.files?.[0];
        if (!file) {
          return;
        }
        if (meta.filetype === 'media') {
          if (file.size / 1024 / 1024 > 200) {
            editorRef.value?.alert({ content: '大小不能超过 200MB' });
            return;
          }
          if (file.type.startsWith('application/pdf')) {
            uploadOss(file).then((res) => {
              const addPath = `<a href="${res.downloadUrl}" target="_blank">${res.name}</a>`;
              content.value = content.value + addPath;
            });
            return;
          }
          if (!file.type.startsWith('video/')) {
            editorRef.value?.alert({ content: '只能选择视频文件' });
            return;
          }
          uploadOss(file).then((res) => {
            callback(res.path);
          });
        }
        // const reader = new FileReader();
        // reader.onload = (e) => {
        //   if (e.target?.result != null) {
        //     const blob = new Blob([e.target.result], { type: file.type });
        //     callback(URL.createObjectURL(blob));
        //   }
        // };
        // reader.readAsArrayBuffer(file);
      };
      input.click();
    }
  });

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form,
          info: content.value,
          files: JSON.stringify(files.value)
        };
        // const saveOrUpdate = isUpdate.value ? updateThinkSite : addThinkSite;
        // saveOrUpdate(formData)
        //   .then((msg) => {
        //     loading.value = false;
        //     message.success(msg);
        //     updateVisible(false);
        //     emit('done');
        //   })
        //   .catch((e) => {
        //     loading.value = false;
        //     message.error(e.message);
        //   });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        files.value = [];
        content.value = '';
        if (props.data) {
          assignObject(form, props.data);
          if (form.info) {
            content.value = form.info;
          }
          if (props.data.thumb) {
            images.value.push({
              uid: uuid(),
              url: props.data.thumb,
              status: 'done'
            });
          }
          if (props.data.files) {
            const arr = JSON.parse(props.data.files);
            arr.map((item) => {
              files.value.push({
                uid: uuid(),
                url: item.url,
                status: 'done'
              });
            });
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
